﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Web;
using MmsApiDemo.WebReference;

namespace MmsApiDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private MobsetApi mobsetMms;
        private void Form1_Load(object sender, EventArgs e)
        {
            mobsetMms = new MobsetApi();

            Memo.Text = "使用说明:\r\n\r\n1、输入企业ID、帐号、密码。\r\n\r\n2、选择每帧对应的素材文件，点击\"插入帧\"。（文本文件必须是UTF-8编码）\r\n\r\n3、点击\"上传彩信文件\"。\r\n\r\n4、上传彩信文件取得彩信文件ID后输入目标号码发送彩信。";
        }
        private byte[] FileToBytes(string fileName)
        {
            FileStream stream = new FileInfo(fileName).OpenRead();
            Byte[] buffer = new Byte[stream.Length];
            ////从流中读取字节块并将该数据写入给定缓冲区buffer中
            stream.Read(buffer, 0, Convert.ToInt32(stream.Length));
            stream.Close();
            return buffer;
        }
        private String FileToString(string fileName)
        {
            Encoding r = GetType(fileName);
            //StreamReader stream = new StreamReader(fileName);
            //StreamReader stream = new StreamReader(fileName,Encoding.GetEncoding("gb2312"));
            StreamReader stream = new StreamReader(fileName, r);
            String str = stream.ReadToEnd();
            return str;

        }

        /// <summary>
        /// 给定文件的路径，读取文件的二进制数据，判断文件的编码类型
        /// </summary>
        /// <param name="FILE_NAME">文件路径</param>
        /// <returns>文件的编码类型</returns>
        public static System.Text.Encoding GetType(string FILE_NAME)
        {
            FileStream fs = new FileStream(FILE_NAME, FileMode.Open, FileAccess.Read);
            Encoding r = GetType(fs);
            fs.Close();
            return r;
        }

        /// <summary>
        /// 通过给定的文件流，判断文件的编码类型
        /// </summary>
        /// <param name="fs">文件流</param>
        /// <returns>文件的编码类型</returns>
        public static System.Text.Encoding GetType(FileStream fs)
        {
            byte[] Unicode = new byte[] { 0xFF, 0xFE, 0x41 };
            byte[] UnicodeBIG = new byte[] { 0xFE, 0xFF, 0x00 };
            byte[] UTF8 = new byte[] { 0xEF, 0xBB, 0xBF }; //带BOM
            Encoding reVal = Encoding.Default;

            BinaryReader r = new BinaryReader(fs, System.Text.Encoding.Default);
            int i;
            int.TryParse(fs.Length.ToString(), out i);
            byte[] ss = r.ReadBytes(i);
            if (IsUTF8Bytes(ss) || (ss[0] == 0xEF && ss[1] == 0xBB && ss[2] == 0xBF))
            {
                reVal = Encoding.UTF8;
            }
            else if (ss[0] == 0xFE && ss[1] == 0xFF && ss[2] == 0x00)
            {
                reVal = Encoding.BigEndianUnicode;
            }
            else if (ss[0] == 0xFF && ss[1] == 0xFE && ss[2] == 0x41)
            {
                reVal = Encoding.Unicode;
            }
            r.Close();
            return reVal;

        }

        /// <summary>
        /// 判断是否是不带 BOM 的 UTF8 格式
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        private static bool IsUTF8Bytes(byte[] data)
        {
            int charByteCounter = 1;　 //计算当前正分析的字符应还有的字节数
            byte curByte; //当前分析的字节.
            for (int i = 0; i < data.Length; i++)
            {
                curByte = data[i];
                if (charByteCounter == 1)
                {
                    if (curByte >= 0x80)
                    {
                        //判断当前
                        while (((curByte <<= 1) & 0x80) != 0)
                        {
                            charByteCounter++;
                        }
                        //标记位首位若为非0 则至少以2个1开始 如:110XXXXX...........1111110X　
                        if (charByteCounter == 1 || charByteCounter > 6)
                        {
                            return false;
                        }
                    }
                }
                else
                {
                    //若是UTF-8 此时第一位必须为1
                    if ((curByte & 0xC0) != 0x80)
                    {
                        return false;
                    }
                    charByteCounter--;
                }
            }
            if (charByteCounter > 1)
            {
                throw new Exception("非预期的byte格式");
            }
            return true;
        }

        private void btnUploadNum_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "txt files (*.txt)|*.txt";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                String strFileName = openFileDialog.FileName;

                string errMsg;
                long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
                string strLoginName = this.txtUserName.Text.Trim();
                string strPasswd = this.txtPassword.Text.Trim();
                string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
                string strInput = lCorpID + strPasswd + strTimeStamp;
                string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");
                String strSubject = "测试号码文件";
                long bAutoDelete = 0;


                byte[] filedata = FileToBytes(strFileName);

                long ret = mobsetMms.Task_UpFile(lCorpID, strLoginName, strMd5, strTimeStamp, strSubject, bAutoDelete, filedata, out errMsg);
                if (ret <= 0)
                {
                    MessageBox.Show("上传失败！" + ret + "\r\n" + errMsg);
                }
                else
                {
                    MmsFileID.Text = ret.ToString();

                    MessageBox.Show("上传成功，号码文件ID:" + ret + "\r\n" + errMsg);

                }


            }

        }

        private void btnMmsState_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            MmsReportGroup[] MmsReportList = new MmsReportGroup[20];
            long ret = mobsetMms.Mms_GetReport(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg, out MmsReportList);
            if (ret > 0)
            {
                MessageBox.Show("取彩信状态报告成功！" + ret + "\r\n" + MmsReportList[0].MmsID + "\r\n" + MmsReportList[0].Status + "\r\n" + MmsReportList[0].ExStatus + "\r\n" + MmsReportList[0].ReportTime);
            }
            else
            {
                MessageBox.Show("取彩信状态报告失败！" + ret + "\r\n" + errMsg);
            }
        }

        private void btnDeleteNum_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.MmsFileID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入号码文件ID！");
                this.MmsFileID.Focus();
                return;
            }

            long TaskFileID = int.Parse(this.MmsFileID.Text.Trim());

            long ret = mobsetMms.Task_DelFile(lCorpID, strLoginName, strMd5, strTimeStamp, TaskFileID, out errMsg);
            if (ret != 0)
            {
                MessageBox.Show("删除失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("删除成功，返回:" + ret + "\r\n" + errMsg);

            }
        }

        private void btnSubmit_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            String tAtTime = "";// = "2005-05-05 12:00:00"; //定时时间，yyyy-MM-dd HH:mm:ss
            long lLongSms = 1;  //使用长短信方式发送
            long lPriority = 5;  //优先级，数值越小，发送越快0-100


            if (this.MmsFileID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入号码文件ID！");
                this.MmsFileID.Focus();
                return;
            }
            if (txtSmsContent.Text.Length <= 0)
            {
                MessageBox.Show("请先输入短信内容！");
                this.txtSmsContent.Focus();
                return;
            }

            MobileFileGroup[] MobileFiles = new MobileFileGroup[2];

            MobileFiles[0] = new MobileFileGroup();
            MobileFiles[0].TaskFileType = 0; //号码文件类型，0-直接手机号码
            MobileFiles[0].TaskFileID = "13922455188"; //号码文件ID，这里输入手机号码

            MobileFiles[1] = new MobileFileGroup();
            MobileFiles[1].TaskFileType = 1; //号码文件类型，1-号码文件ID
            MobileFiles[1].TaskFileID = MmsFileID.Text; //号码文件ID

            long TaskFileID = int.Parse(this.MmsFileID.Text.Trim());

            long ret = mobsetMms.Task_SmsSend(lCorpID, strLoginName, strMd5, strTimeStamp, txtSmsContent.Text, lLongSms, lPriority, tAtTime, MobileFiles, out errMsg);
            if (ret <= 0)
            {
                MessageBox.Show("提交短信任务失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                this.MmsID.Text = ret.ToString();
                MessageBox.Show("提交短信任务成功，返回:" + ret + "\r\n" + errMsg);

            }
        }
        /// <summary>
        /// 取短信任务状态
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTaskState_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.MmsID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入短信任务ID！");
                this.MmsID.Focus();
                return;
            }

            long TaskSmsID = int.Parse(this.MmsID.Text.Trim());

            long MobileCount;
            long YFMobileCount;
            string BeginTime;
            string EndTime;
            long ret = mobsetMms.Task_GetSmsStatus(lCorpID, strLoginName, strMd5, strTimeStamp, TaskSmsID, out errMsg, out MobileCount, out YFMobileCount, out BeginTime, out EndTime);
            if (ret <= 0)
            {
                MessageBox.Show("取短信任务状态失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("取短信任务状态成功:" + ret + "\r\n" + errMsg + "\r\n" + "号码数量:" + MobileCount + "\r\n已发号码数量:" + YFMobileCount + "\r\n发送开始时间:" + BeginTime + "\r\n发送结束时间:" + EndTime);

            }
        }

        private void btnStopState_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.MmsID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入短信任务ID！");
                this.MmsID.Focus();
                return;
            }

            long TaskSmsID = int.Parse(this.MmsID.Text.Trim());

            long ret = mobsetMms.Task_SmsStop(lCorpID, strLoginName, strMd5, strTimeStamp, TaskSmsID, out errMsg);
            if (ret != 0)
            {
                MessageBox.Show("停止短信任务失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("停止短信任务成功:" + ret + "\r\n" + errMsg);

            }

        }

        private void btnSubmitMmsTask_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            String tAtTime = "2011-07-09 21:30";// = "2005-05-05 12:00:00"; //定时时间，yyyy-MM-dd HH:mm:ss
            long lPriority = 5;  //优先级，数值越小，发送越快0-100


            if (this.MmsFileID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入号码文件ID！");
                this.MmsFileID.Focus();
                return;
            }
            if (this.MmsFileID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信文件ID！");
                this.txtMmsID.Focus();
                return;
            }
            long lMmsFileID = int.Parse(txtMmsID.Text);

            MobileFileGroup[] MobileFiles = new MobileFileGroup[2];

            MobileFiles[0] = new MobileFileGroup();
            MobileFiles[0].TaskFileType = 0; //号码文件类型，0-直接手机号码
            MobileFiles[0].TaskFileID = "13922455188"; //号码文件ID，这里输入手机号码

            MobileFiles[1] = new MobileFileGroup();
            MobileFiles[1].TaskFileType = 1; //号码文件类型，1-号码文件ID
            MobileFiles[1].TaskFileID = MmsFileID.Text; //号码文件ID

            long TaskFileID = int.Parse(this.MmsFileID.Text.Trim());

            long ret = mobsetMms.Task_MmsSend(lCorpID, strLoginName, strMd5, strTimeStamp, lMmsFileID, lPriority, tAtTime, MobileFiles, out errMsg);
            if (ret <= 0)
            {
                MessageBox.Show("提交彩信任务失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                this.txtCaiID.Text = ret.ToString();
                MessageBox.Show("提交彩信任务成功，返回:" + ret + "\r\n" + errMsg);

            }

        }

        private void btnMmsTaskState_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.txtCaiID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信任务ID！");
                this.txtCaiID.Focus();
                return;
            }

            long TaskSmsID = int.Parse(this.txtCaiID.Text.Trim());

            long MobileCount;
            long YFMobileCount;
            string BeginTime;
            string EndTime;
            long ret = mobsetMms.Task_GetMmsStatus(lCorpID, strLoginName, strMd5, strTimeStamp, TaskSmsID, out errMsg, out MobileCount, out YFMobileCount, out BeginTime, out EndTime);
            if (ret <= 0)
            {
                MessageBox.Show("取彩信任务状态失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("取彩信任务状态成功:" + ret + "\r\n" + errMsg + "\r\n" + "号码数量:" + MobileCount + "\r\n已发号码数量:" + YFMobileCount + "\r\n发送开始时间:" + BeginTime + "\r\n发送结束时间:" + EndTime);

            }
        }

        private void btnStopMmsTask_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.txtCaiID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信任务ID！");
                this.txtCaiID.Focus();
                return;
            }

            long TaskSmsID = int.Parse(this.txtCaiID.Text.Trim());

            long ret = mobsetMms.Task_MmsStop(lCorpID, strLoginName, strMd5, strTimeStamp, TaskSmsID, out errMsg);
            if (ret != 0)
            {
                MessageBox.Show("停止彩信任务失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("停止彩信任务成功:" + ret + "\r\n" + errMsg);

            }

        }

        private void btnMmsfileState_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            if (this.txtMmsID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信文件ID！");
                this.txtMmsID.Focus();
                return;
            }

            long MmsFileID = int.Parse(this.txtMmsID.Text.Trim());

            long Size;
            string Title;
            string CreateTime;
            long ret = mobsetMms.Mms_GetFileStatus(lCorpID, strLoginName, strMd5, strTimeStamp, MmsFileID, out errMsg, out Title, out Size, out CreateTime);
            if (ret < 0)
            {
                MessageBox.Show("取彩信文件状态失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("取彩信文件状态成功:" + ret + "\r\n" + errMsg + "\r\n" + "彩信标题:" + Title + "\r\n彩信大小:" + Size + "\r\n创建时间:" + CreateTime);

            }
        }

        private void btnSendSms_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            String strAddNum = "001";  //扩展码
            String tTimer = "";// = "2005-05-05 12:00:00"; //定时时间，yyyy-MM-dd HH:mm:ss
            String[] strMobiles = new String[2];  //目标号码
            long lLongSms = 1;  //使用长短信方式发送
            strMobiles[0] = this.txtSmsNum.Text;
            strMobiles[1] = this.txtSmsNum.Text;
            if (this.txtSmsContent.Text.Length <= 0)
            {
                MessageBox.Show("请先输入短信内容！");
                this.txtSmsContent.Focus();
                return;
            }
            String strMsg = this.txtSmsContent.Text;

            SmsIDGroup[] smsIDGroup = new SmsIDGroup[2];
            //long ret = mobsetMms.Sms_Send(lCorpID, strLoginName, strMd5, strTimeStamp, strAddNum, tTimer, lLongSms, strMobiles, strMsg, out errMsg, out smsIDGroup);

            MobileListGroup[] strMobiles2 = new MobileListGroup[1];  //目标号码
            strMobiles2[0] = new MobileListGroup();
            strMobiles2[0].Mobile = this.txtSmsNum.Text;
            //strMobiles2[1] = new MobileListGroup();
            //strMobiles2[1].Mobile = this.Mobile.Text;
            long ret = mobsetMms.Sms_Send(lCorpID, strLoginName, strMd5, strTimeStamp, strAddNum, tTimer, lLongSms, strMobiles2, strMsg, out errMsg, out smsIDGroup);
            if (ret <= 0)
            {
                MessageBox.Show("发送失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                this.MmsID.Text = smsIDGroup[0].SmsID.ToString();
                MessageBox.Show("发送成功，成功数量:" + ret + "\r\n" + errMsg);
            }
        }

        private void btnSign_Click(object sender, EventArgs e)
        {
            string errMsg, strSign;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            long ret = mobsetMms.Sms_GetSign(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg, out strSign);
            if (ret >= 0)
            {
                MessageBox.Show("取签名成功！" + ret + "\r\n" + strSign);
            }
            else
            {
                MessageBox.Show("取签名失败！" + ret + "\r\n" + errMsg);
            }

        }

        private void btnLeave_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            long ret = mobsetMms.Sms_GetBalance(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg);
            if (ret >= 0)
            {
                MessageBox.Show("取短信余额成功！" + ret + "\r\n" + errMsg);
            }
            else
            {
                MessageBox.Show("取短信余额失败！" + ret + "\r\n" + errMsg);
            }
        }

        private void btnReceive_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            SmsRecvGroup[] SmsRecvList = new SmsRecvGroup[20];
            long ret = mobsetMms.Sms_GetRecv(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg, out SmsRecvList);
            if (ret > 0)
            {
                MessageBox.Show("取上行短信成功！" + ret + "\r\n" + SmsRecvList[0].Mobile + "\r\n" + SmsRecvList[0].RecvNum + "\r\n" + SmsRecvList[0].AddNum + "\r\n" + SmsRecvList[0].RecvTime + "\r\n" + SmsRecvList[0].Content);
            }
            else
            {
                MessageBox.Show("取上行短信失败！" + ret + "\r\n" + errMsg);
            }
        }

        private void btnReport_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            SmsReportGroup[] SmsReportList = new SmsReportGroup[20];
            long ret = mobsetMms.Sms_GetReport(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg, out SmsReportList);
            if (ret > 0)
            {
                MessageBox.Show("取短信状态报告成功！" + ret + "\r\n" + SmsReportList[0].SmsID + "\r\n" + SmsReportList[0].Status + "\r\n" + SmsReportList[0].ExStatus + "\r\n" + SmsReportList[0].ReportTime);
            }
            else
            {
                MessageBox.Show("取短信状态报告失败！" + ret + "\r\n" + errMsg);
            }
        }

        private void btnMmsRecieve_Click(object sender, EventArgs e)
        {
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            string Mobile, RecvNum, AddNum, Subject, RecvTime;
            MmsRecvFileGroup[] mmsRecvFile = new MmsRecvFileGroup[20];
            long ret = mobsetMms.Mms_GetRecv(lCorpID, strLoginName, strMd5, strTimeStamp, out errMsg, out Mobile, out RecvNum, out AddNum, out Subject, out RecvTime, out mmsRecvFile);
            if (ret > 0)
            {
                for (int i = 0; i < mmsRecvFile.Length; i++)
                {
                    String strFileName;// = "d:";
                    strFileName = mmsRecvFile[i].FileName + mmsRecvFile[i].FileType;
                    strFileName = strFileName.Replace("\\", "_");
                    strFileName = strFileName.Replace("/", "_");
                    strFileName = "d:\\" + strFileName;
                    Stream stream = new FileStream(strFileName, FileMode.CreateNew, FileAccess.Write, FileShare.None);
                    if (stream.CanWrite)
                    {
                        stream.Write(mmsRecvFile[i].FileData, 0, mmsRecvFile[i].FileData.Length);
                        stream.Close();
                    }
                }
                MessageBox.Show("取上行彩信成功！" + ret + "\r\n" + Mobile + "\r\n" + RecvNum + "\r\n" + AddNum + "\r\n" + RecvTime + "\r\n" + Subject);
            }
            else
            {
                MessageBox.Show("取上行彩信失败！" + ret + "\r\n" + errMsg);
            }
        }

        private void btnTextBrower_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "txt files (*.txt)|*.txt";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                this.txtText.Text = openFileDialog.FileName;
            }
        }

        private void btnPicBrouw_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "jpg files (*.jpg)|*.jpg|gif files (*.gif)|*.gif";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                this.txtPic.Text = openFileDialog.FileName;
            }
        }

        private void btnVioceBrower_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "mid files(*.mid)|*.mid|midi files(*.midi)|*.midi|amr files(*.amr)|*.amr";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                this.txtAudioFileName.Text = openFileDialog.FileName;
            }
        }

        private void btnInsertScrolls_Click(object sender, EventArgs e)
        {

            int currectCount = this.listView1.Items.Count;
            if (this.txtText.Text != "" || this.txtPic.Text != "" || this.txtAudioFileName.Text != "")
            {
                this.listView1.Items.Add(new ListViewItem(new string[] { currectCount.ToString(), this.txtText.Text, this.txtPic.Text, this.txtAudioFileName.Text }));
                this.txtAudioFileName.Text = "";
                this.txtPic.Text = "";
                this.txtText.Text = "";
            }
            else
            {
                MessageBox.Show("图像、文本、声音至少指定一种素材才能插入帧！");
                return;
            }
        }

        private void btnDeleteScrolls_Click(object sender, EventArgs e)
        {
            if (this.listView1.SelectedItems.Count > 0)
            {
                for (int i = 0; i < this.listView1.SelectedItems.Count; )
                {
                    this.listView1.SelectedItems[i].Remove();
                }
            }
        }

        private void btnUploadMmsFile_Click(object sender, EventArgs e)
        {
            if (this.listView1.Items.Count <= 0)
            {
                MessageBox.Show(this, "请先至少插入一帧再上传！");
                return;
            }
            if (txtMmsTitle.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信标题！");
                txtMmsTitle.Focus();
                return;
            }
            if (this.txtCorpId.Text.Length <= 0)
            {
                MessageBox.Show("请输入企业ID！");
                this.txtCorpId.Focus();
                return;
            }
            if (this.txtUserName.Text.Length <= 0)
            {
                MessageBox.Show("请输入登录名！");
                txtUserName.Focus();
                return;
            }
            if (this.txtPassword.Text.Length <= 0)
            {
                MessageBox.Show("请输入密码！");
                txtPassword.Focus();
                return;
            }
            MmsFileGroup[] mmsFiles = new MmsFileGroup[this.listView1.Items.Count];
            for (int i = 0; i < mmsFiles.Length; i++)
            {
                mmsFiles[i] = new MmsFileGroup();

                mmsFiles[i].PlayTime = 30;    //当前帧播放时间,可为0-默认。

                if (this.listView1.Items[i].SubItems[1].Text != "")
                {
                    mmsFiles[i].Text_FileName = this.listView1.Items[i].SubItems[1].Text;
                    mmsFiles[i].Text_Content = FileToString(this.listView1.Items[i].SubItems[1].Text);
                }
                if (this.listView1.Items[i].SubItems[2].Text != "")
                {
                    mmsFiles[i].Image_FileName = this.listView1.Items[i].SubItems[2].Text;
                    mmsFiles[i].Image_FileData = FileToBytes(this.listView1.Items[i].SubItems[2].Text);
                }
                if (this.listView1.Items[i].SubItems[3].Text != "")
                {
                    mmsFiles[i].Audio_FileName = this.listView1.Items[i].SubItems[3].Text;
                    mmsFiles[i].Audio_FileData = FileToBytes(this.listView1.Items[i].SubItems[3].Text);
                }
            }
            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text.Trim());
            string strLoginName = this.txtUserName.Text.Trim();
            string strPasswd = this.txtPassword.Text.Trim();
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            long lSmilType = 0;  //0-由系统自动生成smil文件，1-彩信文件中自带smil文件，2-文件方式发送彩信，无需smil文件

            long ret = mobsetMms.Mms_UpFile(lCorpID, strLoginName, strMd5, strTimeStamp, this.txtMmsTitle.Text, lSmilType, mmsFiles, out errMsg);
            if (ret <= 0)
            {
                MessageBox.Show("上传失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                txtMmsID.Text = ret.ToString();
                MessageBox.Show("上传成功，彩信文件ID:" + ret + "\r\n" + errMsg);

            }
        }

        private void btnSendMms_Click(object sender, EventArgs e)
        {
            if (this.txtMmsID.Text.Length <= 0)
            {
                MessageBox.Show("请先输入彩信文件ID！");
                this.txtMmsID.Focus();
                return;
            }
            if (this.txtToNum.Text.Length <= 0)
            {
                MessageBox.Show("请先输入目标号码！");
                this.txtToNum.Focus();
                return;
            }

            string errMsg;
            long lCorpID = int.Parse(this.txtCorpId.Text);
            string strLoginName = this.txtUserName.Text;
            string strPasswd = this.txtPassword.Text;
            string strTimeStamp = DateTime.Now.ToString("MMddHHmmss");
            string strInput = lCorpID + strPasswd + strTimeStamp;
            string strMd5 = System.Web.Security.FormsAuthentication.HashPasswordForStoringInConfigFile(strInput, "MD5");

            long lMmsFileID = int.Parse(this.txtMmsID.Text);  //彩信文件ID
            String strAddNum = "001";  //扩展码
            String tTimer = "";// = "2005-05-05 12:00:00"; //定时时间，yyyy-MM-dd HH:mm:ss
            String[] strMobiles = new String[1];  //目标号码
            strMobiles[0] = this.txtMmsID.Text;

            MmsIDGroup[] mmsIDGroup = new MmsIDGroup[1];
            MobileListGroup[] strMobiles2 = new MobileListGroup[2];  //目标号码
            strMobiles2[0] = new MobileListGroup();
            strMobiles2[0].Mobile = this.txtToNum.Text;
            strMobiles2[1] = new MobileListGroup();
            strMobiles2[1].Mobile = this.txtToNum.Text;

            long ret = mobsetMms.Mms_Send(lCorpID, strLoginName, strMd5, strTimeStamp, strAddNum, tTimer, strMobiles2, lMmsFileID, out errMsg, out mmsIDGroup);
            if (ret <= 0)
            {
                MessageBox.Show("发送彩信失败！" + ret + "\r\n" + errMsg);
            }
            else
            {
                this.txtSentMMSID.Text = mmsIDGroup[0].MmsID.ToString();
                MessageBox.Show("发送彩信成功，成功数量:" + ret + "\r\n" + errMsg);
            }
        }
    }
}
